<template>
    <q-page class="row items-center justify-evenly bg-base">
        <DocumentWrapper ref="wrap" style="width: 100%">

            <Container :max-height="1" style="width: 100%" class="column">
                <q-scroll-area class="col">

                    <grid-layout
                        :layout.sync="layout"
                        :col-num="12"
                        :is-draggable="!$q.screen.lt.md"
                        :responsive="true"
                        :is-resizable="!$q.screen.lt.md"
                        :is-mirrored="false"
                        :vertical-compact="true"
                        :margin="[15, 15]"
                        :use-css-transforms="true"
                    >

                        <grid-item v-for="item in layout"
                                   @moved="Moved"
                                   @resize="Resized"
                                   :x="item.x"
                                   :y="item.y"
                                   :w="item.w"
                                   :h="item.h"
                                   :i="item.i"
                                   :key="item.i">

                            <WidgetShell :widget="Widget(item.i)" @delete="Delete">
                                <WidgetRenderer :widget="Widget(item.i)"/>
                            </WidgetShell>
                        </grid-item>
                    </grid-layout>
                </q-scroll-area>
                <q-btn fab icon="add" class="fixed-bottom-right q-ma-lg" to="/widget/type" color="primary"/>

            </Container>
        </DocumentWrapper>
    </q-page>
</template>

<script lang="ts">


import {Component, Vue} from 'vue-property-decorator';
import LottieAnimation from "components/Core/LottieAnimation.vue";
import Form from "components/FormCore.vue";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import Chart from "components/Core/Chart.vue";
import Container from "components/Core/Container.vue";
import RadioSetting from "components/Filters/RadioSetting.vue";
import VueGridLayout from 'vue-grid-layout';
import WidgetShell from "components/Widget/WidgetShell.vue";
import SingleValueWidget from "components/Widget/SingleValueWidget.vue";
import CompareMetric from "components/Widget/CompareMetricWidget.vue";
import {MetricValue} from "src/classLibrary/Dashboard/SingeMetricQuery";
import RelativeMetricWidget from "components/Widget/RelativeMetricWidget.vue";
import {IWidgetStore, ServerWidgetStore} from "src/classLibrary/Dashboard/WidgetStore";
import {DeepClone, WarnMessage} from "src/classLibrary/Utility";
import WidgetRenderer from "components/Widget/WidgetRenderer.vue";
import {Widget} from "src/classLibrary/Dashboard/Dashboard";

@Component({
    components: {
        WidgetRenderer,
        RelativeMetricWidget,
        CompareMetric,
        SingleValueWidget,
        WidgetShell,
        GridLayout: VueGridLayout.GridLayout,
        GridItem: VueGridLayout.GridItem,
        RadioSetting,
        Container,
        Chart,
        DocumentWrapper, Form, LottieAnimation
    }
})
export default class PageIndex extends Vue {
    layout: any[] = [];

    routeQueries = {
        add: '',
    }

    Widget(s: string) {
        const widgets = DeepClone(this.widgets);
        const r = widgets[s];
        return r;
    }

    rv = MetricValue.Duration(12502);
    lv = MetricValue.Duration(25572);

    widgetStore: IWidgetStore = new ServerWidgetStore(this.$coreApi, this.$auth, this.PersistentStore.StoreValue.project);

    widgets: { [s: string]: Widget } = {};

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    init() {
        if (this.routeQueries.add != '') {
            this.Add(this.routeQueries.add);
            this.routeQueries.add = '';
        }
    }

    async SaveLayout() {
        const r = await this.widgetStore.UpdateLayout(this.layout);
        if (r.isSome()) {
            console.error(r.unwrap());
            this.$q.notify(WarnMessage('failed to add layout'))
        }
    }

    async Add(id: string) {
        await this.loadLayout();
        this.layout.push({
            x: (this.layout.length * 2) % 12,
            y: this.layout.length + 12, // puts it at the bottom
            w: 2,
            h: 2,
            i: id,
        });
        await this.SaveLayout();
    }

    async mounted() {
    }

    async loadLayout() {
        const r = await this.widgetStore.LoadLayout();
        if (r.isErr()) {
            Vue.nextTick(() => {
                this.Wrap.SubmitError(r.unwrapErr())
            })
        }
        this.layout = r.unwrap();

    }

    async loadWidget() {
        const widgetResult = await this.widgetStore.LoadWidgets();

        if (widgetResult.isErr()) {
            Vue.nextTick(() => {
                this.Wrap.SubmitError(widgetResult.unwrapErr())
            })
        }
        console.log('widget result', widgetResult.unwrap());
        this.widgets = DeepClone(widgetResult.unwrap());
    }

    async created() {
        await this.loadLayout();
        await this.loadWidget();
    }

    async Moved() {
        await this.SaveLayout();
    }

    async Resized() {
        console.log('resized');
        await this.SaveLayout();
    }

    async Delete(id: string) {
        this.layout = this.layout.filter((item) => item.i !== id);
        await this.SaveLayout();
    }

};
</script>
